%slwdg_initialize (0);
() = evalfile ("yesno.sl");

variable Quit_Button = slwdg_define_widget (0, BUTTON,
					    "Quit",
					    "", "Press Return to quit.",
					    5, 5, 0, 0,
					    1);

define quit_callback (id, val)
{
   quit ();
}

slwdg_set_callback (Quit_Button, "quit_callback", -1);

() = slwdg_define_widget (0, STATIC_TEXT,
			  "This is a demo.",
			  "", "",
			  1, 1, 0, 0, 1);

variable Exit_Button = slwdg_define_widget (0, BUTTON,
					    "Exit",
					    "", "Press Return to exit.",
					    5, 10, 0, 0,
					    1);



variable ListBox = slwdg_define_widget (0, LIST_BOX,
					"List of items",
					"",
					"Press RETURN to select.",
					40, 8, 0, 3,
					0);

variable EditBox = slwdg_define_widget (0, EDIT_BOX,
					"Enter something here",
					"",
					"This is an edit box.",
					10, 18, 20, 0,
					1);

variable PopupBox = slwdg_define_widget (0, POPUP_BOX,
					"List of Items",
					"",
					"Popup list box",
					40, 10, 0, 0,
					1);

$1 = "item 0";
for ($0 = 1; $0 < 10; $0++)
{
   $1 = Sprintf ("%s\nitem %d", $1, $0, 2);
}
slwdg_set_listbox_items (ListBox,  $1);

slwdg_set_text (PopupBox, slwdg_get_text (ListBox));


define popup_callback (id, msg)
{
   slwdg_popup_widget (ListBox, 1);
   return 0;
}

define listbox_callback (id, msg)
{
   slwdg_popup_widget (ListBox, 0);
   slwdg_set_text (PopupBox, slwdg_get_text (ListBox));
   return 0;
}

slwdg_set_callback (ListBox, "listbox_callback", -1);
slwdg_set_callback (PopupBox, "popup_callback", -1);


define exit_callback (id, msg)
{
   variable ret;
   variable txt;
   
   if (1 == slwdg_get_yes_no_cancel ("Really Quit?")) 
     {
	%ret = slwdg_get_yes_no_cancel ("Files not saved.  Save files?");
	ret = get_yes_no ("Hello?");
	if (ret)
	  {
	     if (ret > 0)
	       {
		  txt = Sprintf ("Listbox: %s\n", slwdg_get_text (ListBox), 1);
		  txt = Sprintf ("%sEditBox: %s\n", txt, slwdg_get_text (EditBox), 2);
		  slwdg_end ();
		  () = fputs (txt, stdout);
	       }
	     else slwdg_end ();
	     quit ();
	  }
     }
   return 0;
}
slwdg_set_callback (Exit_Button, "exit_callback", -1);

slwdg_start ();
slwdg_end ();

%slwdg_message ("Starting again.");
%slwdg_start ();
%slwdg_end ();
quit ();
